/* TRI DE TABLEAU PAR SELECTION DES MINIMUMS SUCCESSIFS
 */

/*@ requires i < n;
  @ requires \valid(t+(i..n-1));
  @ assigns \nothing;
  @ ensures i <= \result < n ;
  @ ensures \forall int k; i <= k < n ==> t[\result] <= t[k];
  @*/
int minimum(int t[], int i,int n) {
  int j;
  // A FAIRE: compléter l'implementation et l'invariant de boucle.
  /*@ loop invariant i < j <= n;
    @ loop assigns j;
    @ loop variant n-j;
    @*/
  for (j=i+1; j < n; j++) {
  }
 return 0;
}

// A FAIRE: écrire et prouver la spécification de manière à ce que les 
//          assertions après le label "L:" ci-dessous soient prouvables !
void swap(int *a, int *b) {
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

/* SPECIFICATIONS DU TRI
 
  Inspiré d'un exemple de Claude Marché.
  http://proval.lri.fr/gallery/SelectionSortACSL.fr.html

 */

/* Échange des éléments d'indices "i" et "j" dans le tableau "a" sans
   toucher au reste du tableau entre deux points de contrôle "L1" et
   "L2" (labels) du programme.
*/
/*@ predicate Swap{L1,L2}(int *a, integer i, integer j) =
  @   \at(a[i],L1) == \at(a[j],L2) &&
  @   \at(a[j],L1) == \at(a[i],L2) &&
  @   \forall integer k; k != i && k != j
  @       ==> \at(a[k],L1) == \at(a[k],L2);
  @*/

/* Permutation dans la tranche "l..h" du tableau "a" sans toucher au
   reste du tableau entre deux points de contrôle "L1" et "L2"
   (labels) du programme.
*/
/*@ axiomatic MyPermutationTheory {
  @  predicate Permut{L1,L2}(int *a, integer l, integer h) ;
  @  axiom Permut_refl{L}:
  @   \forall int *a, integer l, h; Permut{L,L}(a, l, h) ;
  @  axiom Permut_sym{L1,L2}:
  @    \forall int *a, integer l, h;
  @      Permut{L1,L2}(a, l, h) ==> Permut{L2,L1}(a, l, h) ;
  @  axiom Permut_trans{L1,L2,L3}:
  @    \forall int *a, integer l, h;
  @      Permut{L1,L2}(a, l, h) && Permut{L2,L3}(a, l, h) ==>
  @        Permut{L1,L3}(a, l, h) ;
  @  axiom Permut_swap{L1,L2}:
  @    \forall int *a, integer l, h, i, j;
  @       l <= i <= h && l <= j <= h && Swap{L1,L2}(a, i, j) ==>
  @     Permut{L1,L2}(a, l, h) ;
  @ }
  @*/

/* Être un tableau trié dans la tranche "l..h".
*/
/*@ predicate Sorted(int *a, integer l, integer h) =
  @   \forall integer i; l < i <= h ==> a[i-1] <= a[i] ;
  @*/



/*@ requires \valid(t+(0..n-1));
  @ assigns t[0..n-1];
  @ ensures Sorted(t,0,n-1);
  @ ensures Permut{Pre,Here}(t,0,n-1);
  @*/
void min_sort(int t[], int n) {
  int i, m;
  // A FAIRE: compléter l'implementation et l'invariant de boucle.
  /*@ loop invariant 0 <= i && Permut{Pre,Here}(t,0,n-1);
    @ loop assigns i, t[0..n-1], m;
    @ loop variant n-i;
    @*/
  for (i=0; i<n-1; i++) {
    m=minimum(t,i,n);
  L: /* label utile pour les asserts ci-dessous ! */
    swap(t+i,t+m);
    //@ assert Swap{L,Here}(t,i,m);
    //@ assert Permut{L,Here}(t,0,n-1);
  }
}


// MAIN avec TEST de "min_sort"
#include "any.h"
#define N 5

int main() {
  int t[N];
  int i;
  for (i=0; i<N; i++) {
    t[i]=any();
  }
  min_sort(t,N);
  // test seulement du caractère trié ! Pas de la permutation !
  for (i=1; i<N; i++) {
    if (t[i-1]>t[i]) 
      return i; // ERREUR !
  }
  return 0; // trié
}
